/*
 * Created by SharpDevelop.
 * User: supergel
 * Date: 11/2/2008
 * Time: 11:53 AM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.ComponentModel;
using System.Data;
using System.Runtime.InteropServices;
using DirectoryPicker;
using System.Threading;

namespace Steel_Rats
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		public string appran="";
		public string myreport="";
		public string curDir="";
		public string header="";
		public string footer="";
		public int counter =0;
		public string passfile="";
		
		private int upper_c=250;
		private int lower_c=50;
		private int color_iterator= 0;
		
		private Color bcolor = Color.GhostWhite ;
		public string logdir = Directory.GetCurrentDirectory();
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			//header=  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">";
          	
			 bcolor =this.BackColor;
			 color_iterator= this.lower_c;
      
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		void BtnGOClick(object sender, EventArgs e)
		{
			rtbox.Text = "";
			counter=0;
		 Cursor.Current = Cursors.WaitCursor;
		 // golog("Starting up");
		 curDir=Directory.GetCurrentDirectory();
		// MessageBox.Show(curDir );
		appran= DateTime.Now.ToString("yyyyMMdd_H_mm_");
			DirSearch(this.txtDir.Text );
			myreport = this.txtReport.Text + appran +"report.html";
			
		 			
			MessageBox.Show("Steel RATS processed "+counter+" files and the report is located: "+myreport);
			lblURL.Text = "report: "+myreport;
			
			 
			
			Cursor.Current = Cursors.Default; 
			if(myreport.Length >0){
					webBrowser1.Url = new Uri(myreport);
				}
			
			 this.BackColor = bcolor ;
			// golog("finished");
			
		}
	
 	void DirSearch(string sDir) 
{
	try	
	{
		if(this.color_iterator <this.upper_c){
		this.color_iterator++;
		}else{
			
			this.color_iterator = this.lower_c;
		}
		this.BackColor = Color.FromArgb(255,50,this.color_iterator,50);
		// golog("\n\nworking in directory: "+sDir);
		 
		//	MessageBox.Show("checking sDir: "+sDir);
		foreach (string f in Directory.GetFiles(sDir, this.txtFilter.Text)) 
		{
		   //lstFilesFound.Items.Add(f);
		   // golog("About to process file: "+f);
		   
		   /// <summary>
		   /// Pop off new threads to run the commandline program
		   /// </summary>
		   /// <param name="theFile"></param>
		   MainForm tt = new MainForm();
		   tt.passfile = f;
		   tt.curDir = curDir;
		   tt.cboWarn.SelectedItem = cboWarn.SelectedItem;
		   //appran
		   tt.appran = appran;
		   tt.counter =  counter;
		   tt.txtReport.Text = txtReport.Text;
		   rtbox.Text = rtbox.Text + "\n" + f  ;
		   tt.Visible=false;
		   Thread rundown = new Thread(new ThreadStart(  tt.threadrunrats ));
		   rundown.IsBackground = true;
		   
		   rundown.Start();
		   counter = counter+1;
		   
		   // run single threaded call
		   //runrats(f);
		    
		    
		  this.lblCounter.Text = "Processed # "+counter;
		  this.Refresh();
		  
		  Application.DoEvents();
		  
		  //wait a tenth of a second to give the previous thread a chance to execute
		  System.Threading.Thread.Sleep(10);
		}
		
	   foreach (string d in Directory.GetDirectories(sDir)) 
	   {
	    
		DirSearch(d);
	   }
	}
	catch (System.Exception excpt) 
	{
		Console.WriteLine(excpt.Message);
	}
}
	 void  runrats(string theFile){
		try{
				rtbox.Text = rtbox.Text + "\n" + theFile  ;
				System.Diagnostics.ProcessStartInfo procStartInfo =
				new System.Diagnostics.ProcessStartInfo(  curDir+@"\rats-2.1\rats.exe");
				
				procStartInfo.Arguments =  @" --html -r  --noheader --nofooter --context -w"+this.cboWarn.SelectedItem.ToString() +" -i "+ theFile  ;
				
				procStartInfo.RedirectStandardOutput = true;
				procStartInfo.UseShellExecute = false;
				// Do not create the black window.
				procStartInfo.CreateNoWindow = true;
				
				
				System.Diagnostics.Process proc = new System.Diagnostics.Process();
				
				proc.StartInfo = procStartInfo;
				
				proc.EnableRaisingEvents=false;
				
				// golog("Before starting : "+ procStartInfo.Arguments );
				proc.Start();
				
				//System.Threading.Thread.Sleep(100);
				
				proc.WaitForExit();

string result = proc.StandardOutput.ReadToEnd();

				// sanitize result so it is all one file
				if(counter!=0){
					// this leaves the header info in the document the first time around.
				result = result.Replace("<html>","\n");
				result = result.Replace("<head></head>","\n");
				result = result.Replace("<body>","\n");
				}else{
					result = result.Replace("<head></head>","<head><title>Steel RATS ran on :"+appran+"</title></head>");
				}
				
				result = result.Replace("</body></html>","\n");
				
				result = result.Replace("Severity: Low","<hr><p style='font-family:verdana;font-weight:bold;font-size:130%;color:yellow;background-color: black'>Severity: Low</p>");
				result = result.Replace("Severity: Medium","<hr><p style='font-family:verdana;font-weight:bold;font-size:130%;color:orange;background-color: black'>Severity: Medium</p>");
				result = result.Replace("Severity: High","<hr><p style='font-family:verdana;font-weight:bold;font-size:130%;color:red;background-color: black'>Severity: High</p>");			
				
//MessageBox.Show(result);
counter = counter+1;			
			// create a writer and open the file
			string filename = this.txtReport.Text + appran +"report.html";
			
			TextWriter tw = new StreamWriter(filename , true);
			
			//myreport = filename;
		 
			tw.WriteLine(result);
			// close the stream
			tw.Close();
			 

			}catch(Exception ex){
				MessageBox.Show(ex.ToString()  );
			}
	}
		 
	 void  threadrunrats(){
		try{
 			
 			string theFile = passfile;
			 
    System.Diagnostics.ProcessStartInfo procStartInfo =
        new System.Diagnostics.ProcessStartInfo(  curDir+@"\rats-2.1\rats.exe");
 
    procStartInfo.Arguments =  @" --html -r  --noheader --nofooter --context -w"+this.cboWarn.SelectedItem.ToString() +" -i "+ theFile  ;
 
			procStartInfo.RedirectStandardOutput = true;
    procStartInfo.UseShellExecute = false;
    // Do not create the black window.
    procStartInfo.CreateNoWindow = true;

    
    System.Diagnostics.Process proc = new System.Diagnostics.Process();
    
 proc.StartInfo = procStartInfo;
 
proc.EnableRaisingEvents=false;
 
// golog("Before starting : "+ procStartInfo.Arguments );
proc.Start();

//System.Threading.Thread.Sleep(50);

proc.WaitForExit();

string result = proc.StandardOutput.ReadToEnd();
//MessageBox.Show(result); 
				// sanitize result so it is all one file
				if(counter!=0){
					// this leaves the header info in the document the first time around.
				result = result.Replace("<html>","\n");
				result = result.Replace("<head></head>","\n");
				result = result.Replace("<body>","\n");
				}else{
					result = result.Replace("<head></head>","<head><title>Steel RATS ran on :"+appran+"</title></head>");
				}
				
				result = result.Replace("</body></html>","\n");
				
				result = result.Replace("Severity: Low","<hr><p style='font-family:verdana;font-weight:bold;font-size:130%;color:yellow;background-color: black'>Severity: Low</p>");
				result = result.Replace("Severity: Medium","<hr><p style='font-family:verdana;font-weight:bold;font-size:130%;color:orange;background-color: black'>Severity: Medium</p>");
				result = result.Replace("Severity: High","<hr><p style='font-family:verdana;font-weight:bold;font-size:130%;color:red;background-color: black'>Severity: High</p>");			
				
//MessageBox.Show(result);
counter = counter+1;			
				// create a writer and open the file
				//	string filename = curDir +"\\scratch\\" + appran + counter + "report.html";
		
			  go_write_result(  result);

			}catch(Exception ex){
				MessageBox.Show(ex.ToString()  );
			}
	}
 	
 	
 	void go_write_result(string result){
 		
 		try{
				string filename = this.txtReport.Text + appran +"report.html";	
				TextWriter tw = new StreamWriter(filename , true);
				
				myreport = filename;
				
				tw.WriteLine(result);
				// close the stream
				tw.Close();
 		}catch(Exception ex){
 			
 			Thread.Sleep(100);
 			go_write_result(result);
 		}
				
 		
 	}
 	
 	
 
		void TxtDirEnter(object sender, EventArgs e)
		{
				DirPicker DP = new DirPicker();
			DP.ShowDialog();
			if(DP.Result==DirectoryPickerResponse.Ok)
			{
				//MessageBox.Show("Ok: "+ DP.SelectedDirectory);
				txtDir.Text = DP.SelectedDirectory;
			}
			else
			{
				MessageBox.Show("Cancel!");
			}
		}
		
		void TxtReportEnter(object sender, EventArgs e)
		{
				DirPicker DP = new DirPicker();
			DP.ShowDialog();
			if(DP.Result==DirectoryPickerResponse.Ok)
			{
				//MessageBox.Show("Ok: "+ DP.SelectedDirectory);
				txtReport.Text = DP.SelectedDirectory;
			}
			else
			{
				MessageBox.Show("Cancel!");
			}
		}
		
		void MainFormLoad(object sender, EventArgs e)
		{
			this.cboWarn.SelectedIndex=2;
		}
		
		void AboutToolStripMenuItemClick(object sender, EventArgs e)
		{
			MessageBox.Show("\"Steel Rats\" is a simple gui wrapper for \nRATS - Rough Auditinig Tool for Security\nwrapper by John Aho");
		}
		
		void BtnReportDirClick(object sender, EventArgs e)
		{
			System.Diagnostics.Process.Start(this.txtReport.Text);
		}
		
		void golog(string item){
			// curDir
			 
			try{  
				string filename = logdir+"\\log.txt";
			//	MessageBox.Show(filename);
		//	string filename = Directory.GetCurrentDirectory()+"log.txt";			
			TextWriter tw = new StreamWriter(filename , true);
			
			 		 
			tw.WriteLine(item);
			// close the stream
			tw.Close();
			 

			}catch(Exception ex){
				MessageBox.Show(ex.ToString()  );
			}
		}
		
		void BtnList_CopyClick(object sender, EventArgs e)
		{
			Clipboard.SetDataObject( rtbox.Text, true );
		}
	}
}
